<?php 
/*
Plugin Name: WP Get Personal
Plugin URI: http://www.wpgetpersonal.com
Description: Allows you to personalise your pages simply by adding the name to the end of the URL.
Author: Steven Henty
Version: 1.1
Author URI: http://www.stevenhenty.com
*/


define(WPGETPPERSONAL_DEBUG, false);

function debug_message( $text, $var ){
	if (WPGETPPERSONAL_DEBUG) {
	 
		echo $text;

		echo '<pre>';
		//esc_html(var_dump($var));
		//var_dump($var);
		echo $var;
		echo '</pre>';
	}
}



function wpgetpersonal_init_method() {

	// only trigger on a 404 error
	global $wp_query;
	if (!$wp_query->is_404){
		return;
	}	

	$wpgetpersonal_request_url = $_SERVER['REQUEST_URI'];   
	$wpgetpersonal_complete_url = "http://".$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
	$wpgetpersonal_wpurl = get_bloginfo('url')."/"; 
	

	//if we're in the admin area exit
	$wpgetpersonal_epos = strpos($wpgetpersonal_complete_url, get_admin_url());
	if ($wpgetpersonal_epos) {
	return;
	}
	

	$wpgetpersonal_params_strpos = strpos($wpgetpersonal_request_url, "?");

	$wpgetpersonal_params = '';  
	if ($wpgetpersonal_params_strpos !== false){
		
		$wpgetpersonal_params = substr($wpgetpersonal_request_url, $wpgetpersonal_params_strpos);
		$wpgetpersonal_request_url = substr( $wpgetpersonal_request_url , 0 , $wpgetpersonal_params_strpos);
	}

	$wpgetpersonal_wpgp_strpos = strpos($wpgetpersonal_params, "wpgp=");
	if ($wpgetpersonal_wpgp_strpos !== false) {
	return;
	}
	
	$wpgetpersonal_url_array = explode("/",$wpgetpersonal_request_url);
	
	$totalarr = count($wpgetpersonal_url_array); 
	if (empty($wpgetpersonal_url_array[$totalarr-1])) {
		$totalarr -= 1;
	}
														
	$wpgetpersonal_contactinfo = $wpgetpersonal_url_array[$totalarr-1];
	$wpgetpersonal_pagename = $wpgetpersonal_url_array[$totalarr-2];
	
	if ($wpgetpersonal_contactinfo == "") {
	return;
	}
	
	// test to see if it's the homepage we need to deliver
	$wpgetpersonal_contactinfo_strpos = strpos($wpgetpersonal_complete_url, $wpgetpersonal_contactinfo);
	$wpgetpersonal_first_part = substr( $wpgetpersonal_complete_url , 0 , $wpgetpersonal_contactinfo_strpos);
	if ($wpgetpersonal_first_part == $wpgetpersonal_wpurl) {
		//looks like we have to take the user to the homepage

		//if it's a page - check the wpgetpersonal setting
		$wpgetpersonal_wp_page_on_front = get_option('page_on_front');
		if ($wpgetpersonal_wp_page_on_front != 0) {
		
			$wpgetpersonal_meta_value = get_post_meta($wpgetpersonal_wp_page_on_front, 'wpgetpersonal' , true);
			if(empty($wpgetpersonal_meta_value)) {
				return;
			}
		}
		else {
			// homepage is blog
			// comment this next line to enable wp get personal on the homepage
			return;
		}
		
		$wpgetpersonal_pagename = "";
		$wpgetpersonal_base_url = $wpgetpersonal_wpurl;
	}
	else {
		$wpgetpersonal_pagename_strpos = strpos($wpgetpersonal_complete_url, $wpgetpersonal_pagename);
		
		$wpgetpersonal_base_url = substr( $wpgetpersonal_complete_url , 0 , $wpgetpersonal_pagename_strpos);
		
		
		global $wpdb;
		$page_id = $wpdb->get_var($wpdb->prepare("SELECT ID FROM $wpdb->posts WHERE (post_type = 'page' OR post_type = 'post') AND post_name = '$wpgetpersonal_pagename' AND post_status = 'publish' AND post_parent = 0"));
		$wpgetpersonal_meta_value = get_post_meta($page_id, 'wpgetpersonal' , true);
				
		
		debug_message( "wpgetpersonal_meta_value:", $wpgetpersonal_meta_value );
		debug_message( "page_id:", $page_id );
		

		//debug_message( "mylink:", var_dump($mylink) );
		
		debug_message( "page_id:", $page_id );
		debug_message( "wpgetpersonal_contactinfo:", $wpgetpersonal_contactinfo );
		
		debug_message( "wpgetpersonal_pagename:", $wpgetpersonal_pagename );
		$wpgetpersonal_pagename = $wpgetpersonal_pagename . "/";
		
		if( empty($page_id) ) {
		return;
		}
		
		if(empty($wpgetpersonal_meta_value)) {
		return;
		}
	}
		
	
	if ( is_user_logged_in() ) {
		$wpgp_redirect_url=$wpgetpersonal_base_url .  "$wpgetpersonal_pagename" . $wpgetpersonal_params;
		
		wp_redirect($wpgp_redirect_url);
		exit;
	}
	
	
	
	
	// it looks lke a wpgetspersonal page!
	status_header( 200 );
	$wp_query->is_404 = false;
	
	if ($wpgetpersonal_params == ""){
		$wpgetpersonal_params = "?";
	}
	else {
		$wpgetpersonal_params = $wpgetpersonal_params . "&";
	}
	
	$blog_URL = $wpgetpersonal_base_url . "$wpgetpersonal_pagename" . $wpgetpersonal_params . "wpgp=" . $wpgetpersonal_contactinfo ;   

	
	if (!isset($_COOKIE['WPGP']))
	{
		setcookie("WPGP", $wpgetpersonal_contactinfo, time()+60*60*24*30, COOKIEPATH, COOKIE_DOMAIN);  /* expire in 30 days */
		$response = wp_remote_get($blog_URL);
		
	}
	else
	{
		// cookie is set
		
		// if it's different from the contact name value sent then send a new cookie
		if ($_COOKIE['WPGP'] <> $wpgetpersonal_contactinfo) 
		{
			setcookie("WPGP", $wpgetpersonal_contactinfo, time()+60*60*24*30, COOKIEPATH, COOKIE_DOMAIN);  /* expire in 30 days */
		}
		
		$cookies = "WPGP=" . $_COOKIE['WPGP'];
		$headers = array( 'cookie' => $cookies );
		
		$response = wp_remote_get($blog_URL, array( 'headers' => $headers ));
	
	}

	echo ( $response['body'] );
	
	debug_message( "compurl:", $wpgetpersonal_complete_url );
	debug_message( "URL:", $wpgetpersonal_request_url );
	debug_message( "cookies:", $cookies );
	debug_message( "wpgetpersonal_wpgp_strpos:", $wpgetpersonal_wpgp_strpos );
	debug_message( "wpgetpersonal_contactinfo:", $wpgetpersonal_contactinfo );
	debug_message( "pagename:", $wpgetpersonal_pagename );
	debug_message( "wpgetpersonal_base_url:", $wpgetpersonal_base_url );
	debug_message( "wpgetpersonal_meta_value:", $wpgetpersonal_meta_value );
	debug_message( "wp_query->is_404:", $wp_query->is_404 );
	
	die; 
	
}    

 
 

 //add_action('wp', 'wpgetpersonal_init_method');
add_action('wp', 'wpgetpersonal_init_method');
add_action('add_meta_boxes', 'wpgetpersonal_add_custom_box');
add_action('save_post', 'wpgetpersonal_save_postdata');

function wpgetpersonal_add_custom_box() {
    
    add_meta_box( 'wpgetpersonal_sectionid', __( 'WP Get Personal!', 'wpgetpersonal_textdomain' ), 
                'wpgetpersonal_inner_custom_box', 'page','side' );
	add_meta_box( 'wpgetpersonal_sectionid', __( 'WP Get Personal!', 'wpgetpersonal_textdomain' ), 
	'wpgetpersonal_inner_custom_box', 'post','side' );
}

function wpgetpersonal_inner_custom_box( $post ) {

  // Use nonce for verification
   wp_nonce_field( plugin_basename(__FILE__), 'wpgetpersonal_noncename' );
   $checked = "";
   
   if($_GET['action'] == 'edit'){
	   $postid = $_GET['post'];
	   
	   
	   $wpgetpersonal_meta_value = array();
	   $wpgetpersonal_meta_value = get_post_meta($postid, 'wpgetpersonal' , true);
	   if(!empty($wpgetpersonal_meta_value) == 1){
	   
			if ($wpgetpersonal_meta_value['wpgetpersonal_activated'] == '1') {
	       $checked = "checked='yes'";
		   }
	   }
	   else{
	       $checked = "";
	   }
   }
   
   // The actual fields for data entry
   echo '<label for="wpgetpersonal_activated">' . __("Activate virtual urls", 'wpgetpersonal_textdomain' ) . '</label> ';
   echo '<input type="checkbox" id= "wpgetpersonal_activated" name="wpgetpersonal_activated" value="1"  ' . $checked . '/>';
    echo '<br /><br />Shortcode: [wpgetpersonal]';
}


function wpgetpersonal_save_postdata( $post_id ) {
 
   // verify if this is an auto save routine. 
  // If it is our form has not been submitted, so we dont want to do anything
  if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
      return;
 
 

	  if ( !wp_verify_nonce( $_POST['wpgetpersonal_noncename'], plugin_basename(__FILE__) )) {
		return;
	  }
	 
	  // Check permissions
	 if ( 'page' == $_POST['post_type'] ) {
		if ( !current_user_can( 'edit_page', $post_id ) )
		  return;
	  } else {
		if ( !current_user_can( 'edit_post', $post_id ) )
		  return;
	  }
	 
	 if($_POST['wpgetpersonal_activated'] == ""	){
	  	$_POST['wpgetpersonal_activated'] = 0; 
	 }
	 	
	 $data  = array();
	 $data['post_id'] = $post_id;
	 $data['wpgetpersonal'] = $_POST['wpgetpersonal_activated'];
	

	$wpgetpersonal_meta_value = get_post_meta($post_id, 'wpgetpersonal' , true);
	if ( empty( $wpgetpersonal_meta_value ) && ( $data['wpgetpersonal'] = "1" )) {
	
		$wpgetpersonal_options = array();
		$wpgetpersonal_options['wpgetpersonal_activated'] = '1';
		 add_post_meta( $post_id, 'wpgetpersonal', $wpgetpersonal_options, true);
	}
	elseif ('' == $data['wpgetpersonal'] && $wpgetpersonal_meta_value) {
		delete_post_meta( $post_id, 'wpgetpersonal');
	}
	//elseif (($wpgetpersonal_meta_value) == "1" AND ($data['wpgetpersonal'] == "0")) {
	//	delete_post_meta( $post_id, 'wpgetpersonal');
	//}
  
  //}
  
}

function wpgetpersonal_shortcode( $atts, $content = null ) {
	
	extract( shortcode_atts( array(
					'fallback' => 'Friend',
					'section' => '0'
	), $atts ) );
	
	$wpqueryvar = get_query_var('wpgp');
	
	/*
	if (!empty($wpqueryvar)) {
			$wpgetpersonal_shortcode_val = get_query_var('cn' ); 
			$wpgetpersonal_shortcode_val = wpgp_getparam($wpgetpersonal_shortcode_val, $param);
	}	
	elseif(isset($_REQUEST['cn']) AND $_REQUEST['cn'] != '')
	*/
	if(isset($_REQUEST['wpgp']) AND $_REQUEST['wpgp'] != '')
	  {
			
			$wpgetpersonal_shortcode_val = $_REQUEST['wpgp']; 

			$wpgetpersonal_shortcode_val = wpgp_getparam($wpgetpersonal_shortcode_val, $section);

			
	  }
	   elseif (isset($_COOKIE['WPGP']))
	  {
			// check to see if there's a WPGP cookie set
			// display it
			// if not 
			
			$wpgetpersonal_shortcode_val = $_COOKIE['WPGP'];
			
			//if logged in then set metadata
			$current_user = wp_get_current_user();
			if ( 0 == $current_user->ID ) {
				// Not logged in.
			} else {
				// Logged in.
				
				$wpgp_user_meta_data = get_user_meta($current_user->ID, 'WPGP', true);
				if (!empty($wpgp_user_meta_data)) {
				update_user_meta($current_user->ID, 'WPGP', $wpgetpersonal_shortcode_val);
				}
				else {
				add_user_meta($current_user->ID, 'WPGP', $wpgetpersonal_shortcode_val, true);
				}	
				
			}

			$wpgetpersonal_shortcode_val = wpgp_getparam($wpgetpersonal_shortcode_val, $section);
			
	  }
	  elseif ( is_user_logged_in() )
	  {
			// no request param, no cookie try user meta data
		
			$current_user = wp_get_current_user();
			
			$wpgetpersonal_shortcode_val = get_user_meta( $current_user->ID, "WPGP" , true );
			
			if (empty($wpgetpersonal_shortcode_val)) {
				$wpgetpersonal_shortcode_val = $fallback; 
			}
			else {
				$wpgetpersonal_shortcode_val = wpgp_getparam($wpgetpersonal_shortcode_val, $section);
			}
			
			
	  }
	  else
	  {
			$wpgetpersonal_shortcode_val = $fallback; 
	  }

	  
	  return $wpgetpersonal_shortcode_val;
}
function wpgp_getparam($wpgetpersonal_shortcode_val,$section ){

	if ($section > 0)
	{
		$section -= 1;
		$wpgetpersonal_shortcode_vals = explode( "-", $wpgetpersonal_shortcode_val);
		$wpgetpersonal_shortcode_val = $wpgetpersonal_shortcode_vals[$section];
	}
	
	return $wpgetpersonal_shortcode_val;
}

add_shortcode( 'wpgetpersonal', 'wpgetpersonal_shortcode' );
add_filter( 'widget_text', 'shortcode_unautop');
add_filter( 'widget_text', 'do_shortcode');

add_filter('wp_title', 'set_page_title');

add_filter('the_title', 'set_page_title');


  function set_page_title($orig_title) { 
    
    // Save registered shortcodes:
    global $shortcode_tags;
    $original = $shortcode_tags;
    
    // Unregister all shortcodes:
    remove_all_shortcodes();
    
    // Register wpgetpersonal shortcode:
	add_shortcode( 'wpgetpersonal', 'wpgetpersonal_shortcode' );
    
    // Process title content with the shortcode:
    $title = do_shortcode( $orig_title );
    
    // Unregister comment shortcodes, restore normal shortcodes
    $shortcode_tags = $original;
    

    return $title;  
  }




?>
